window.Gleam.initSearch([{"doc":"lustre_omnistate","title":"lustre_omnistate","content":"# Lustre Omnistate\n\n## Use Remote State, Locally\n\n[![Package Version](https://img.shields.io/hexpm/v/lustre_omnistate)](https://hex.pm/packages/lustre_omnistate)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/lustre_omnistate/)\n\n```sh\ngleam add lustre_omnistate@1\n```\n```gleam\nimport lustre_omnistate as lo\n\npub type Msg {\n  // .. rest of your Msg type\n  // add messages shared with the remote\n  SharedMessage(SharedMessage)\n  // recieve new state from the remote\n  OmniMessage(lo.OmniMessage(OmniState, json.DecodeError))\n}\n\n// In your main\nlet #(omniinit, omniupdate) =\n  lo.setup(\n  // \n    init,\n    update,\n    transports.websocket(&quot;WEBSOCKETS_URL&quot;),\n    OmniMessage,\n    encoder_decoder,\n  )\n\nlustre.application(omniinit, omniupdate, view)\n\n// Every time you dispatch a `SharedMessage`, the server will recieve the message\n// and every time the server sends a new state, it&#39;ll dispatch on the client!\n\n// See the `example` folder for a chat app use case\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/lustre_omnistate&gt;.\n\n","url":"index.html"},{"doc":"internal/transports/websocket","title":"WebSocket","content":"pub type WebSocket\n\n\nSynonyms:\ninternal/transports/websocket.WebSocket\ninternal/transports/websocket WebSocket","url":"internal/transports/websocket.html#WebSocket"},{"doc":"internal/transports/websocket","title":"WebSocketCloseReason","content":"pub type WebSocketCloseReason {\n  Normal(code: Int, reason: String)\n  GoingAway(code: Int, reason: String)\n  ProtocolError(code: Int, reason: String)\n  UnexpectedTypeOfData(code: Int, reason: String)\n  NoCodeFromServer(code: Int, reason: String)\n  AbnormalClose(code: Int, reason: String)\n  IncomprehensibleFrame(code: Int, reason: String)\n  PolicyViolated(code: Int, reason: String)\n  MessageTooBig(code: Int, reason: String)\n  FailedExtensionNegotation(code: Int, reason: String)\n  UnexpectedFailure(code: Int, reason: String)\n  ServiceRestart(code: Int, reason: String)\n  TryAgainLater(code: Int, reason: String)\n  BadGateway(code: Int, reason: String)\n  FailedTLSHandshake(code: Int, reason: String)\n  OtherCloseReason(code: Int, reason: String)\n}\n\nNormal(code: Int, reason: String)\n\n\nGoingAway(code: Int, reason: String)\n\n\nProtocolError(code: Int, reason: String)\n\n\nUnexpectedTypeOfData(code: Int, reason: String)\n\n\nNoCodeFromServer(code: Int, reason: String)\n\n\nAbnormalClose(code: Int, reason: String)\n\n\nIncomprehensibleFrame(code: Int, reason: String)\n\n\nPolicyViolated(code: Int, reason: String)\n\n\nMessageTooBig(code: Int, reason: String)\n\n\nFailedExtensionNegotation(code: Int, reason: String)\n\n\nUnexpectedFailure(code: Int, reason: String)\n\n\nServiceRestart(code: Int, reason: String)\n\n\nTryAgainLater(code: Int, reason: String)\n\n\nBadGateway(code: Int, reason: String)\n\n\nFailedTLSHandshake(code: Int, reason: String)\n\n\nOtherCloseReason(code: Int, reason: String)\n\n\nSynonyms:\ninternal/transports/websocket.WebSocketCloseReason\ninternal/transports/websocket WebSocketCloseReason","url":"internal/transports/websocket.html#WebSocketCloseReason"},{"doc":"internal/transports/websocket","title":"WebSocketError","content":"pub type WebSocketError {\n  InvalidUrl(message: String)\n  UnsupportedEnvironment(message: String)\n}\n\nInvalidUrl(message: String)\n\n\nUnsupportedEnvironment(message: String)\n\n\nSynonyms:\ninternal/transports/websocket.WebSocketError\ninternal/transports/websocket WebSocketError","url":"internal/transports/websocket.html#WebSocketError"},{"doc":"internal/transports/websocket","title":"WebSocketEvent","content":"pub type WebSocketEvent {\n  OnOpen(WebSocket)\n  OnTextMessage(String)\n  OnBinaryMessage(BitArray)\n  OnClose(WebSocketCloseReason)\n}\n\nOnOpen(WebSocket)\n\n\nOnTextMessage(String)\n\n\nOnBinaryMessage(BitArray)\n\n\nOnClose(WebSocketCloseReason)\n\n\nSynonyms:\ninternal/transports/websocket.WebSocketEvent\ninternal/transports/websocket WebSocketEvent","url":"internal/transports/websocket.html#WebSocketEvent"},{"doc":"internal/transports/websocket","title":"close","content":"pub fn close(ws ws: WebSocket) -&gt; Nil\n\nSynonyms:\ninternal/transports/websocket.close\ninternal/transports/websocket close","url":"internal/transports/websocket.html#close"},{"doc":"internal/transports/websocket","title":"init","content":"pub fn init(path: String) -&gt; Result(WebSocket, WebSocketError)\n Initialize a websocket. These constructs are fully asynchronous, so you must provide a wrapper\n that takes a `WebSocketEvent` and turns it into a lustre message of your application.\n If the path given is a URL, that is used.\n If the path is an absolute path, host and port are taken from\n document.URL, and scheme will become ws for http and wss for https.\n If the path is a relative path, ditto, but the the path will be\n relative to the path from document.URL\nSynonyms:\ninternal/transports/websocket.init\ninternal/transports/websocket init","url":"internal/transports/websocket.html#init"},{"doc":"internal/transports/websocket","title":"listen","content":"pub fn listen(\n  ws: WebSocket,\n  on_open on_open: fn(WebSocket) -&gt; Nil,\n  on_text_message on_text_message: fn(String) -&gt; Nil,\n  on_close on_close: fn(WebSocketCloseReason) -&gt; Nil,\n) -&gt; Nil\n\nSynonyms:\ninternal/transports/websocket.listen\ninternal/transports/websocket listen","url":"internal/transports/websocket.html#listen"},{"doc":"internal/transports/websocket","title":"send","content":"pub fn send(ws ws: WebSocket, msg msg: String) -&gt; Nil\n\nSynonyms:\ninternal/transports/websocket.send\ninternal/transports/websocket send","url":"internal/transports/websocket.html#send"},{"doc":"internal/transports/websocket","title":"internal/transports/websocket","content":"","url":"internal/transports/websocket.html"},{"doc":"transports","title":"Transport","content":"pub type Transport(\n  encoded_msg,\n  encoded_omnistate,\n  down_reason,\n  transport_error,\n) {\n  Transport(\n    listen: fn(TransportHandlers(encoded_omnistate)) -&gt; Nil,\n    send: fn(encoded_msg) -&gt; Nil,\n  )\n}\n\nTransport(\n  listen: fn(TransportHandlers(encoded_omnistate)) -&gt; Nil,\n  send: fn(encoded_msg) -&gt; Nil,\n)\n\n\nSynonyms:\ntransports.Transport\ntransports Transport","url":"transports.html#Transport"},{"doc":"transports","title":"TransportHandlers","content":"pub type TransportHandlers(encoded_omnistate) {\n  TransportHandlers(\n    on_up: fn() -&gt; Nil,\n    on_down: fn(Int, String) -&gt; Nil,\n    on_message: fn(encoded_omnistate) -&gt; Nil,\n    on_init_error: fn(String) -&gt; Nil,\n  )\n}\n\nTransportHandlers(\n  on_up: fn() -&gt; Nil,\n  on_down: fn(Int, String) -&gt; Nil,\n  on_message: fn(encoded_omnistate) -&gt; Nil,\n  on_init_error: fn(String) -&gt; Nil,\n)\n\n\nSynonyms:\ntransports.TransportHandlers\ntransports TransportHandlers","url":"transports.html#TransportHandlers"},{"doc":"transports","title":"websocket","content":"pub fn websocket(path: String) -&gt; Transport(String, String, a, b)\n\nSynonyms:\ntransports.websocket\ntransports websocket","url":"transports.html#websocket"},{"doc":"transports","title":"transports","content":"","url":"transports.html"},{"doc":"lustre_omnistate","title":"EncoderDecoder","content":"pub type EncoderDecoder(\n  encoded_omnistate,\n  omnistate,\n  encoded_msg,\n  msg,\n  decode_error,\n) {\n  EncoderDecoder(\n    msg_encoder: fn(msg) -&gt; Result(encoded_msg, Nil),\n    omnistate_decoder: fn(encoded_omnistate) -&gt;\n      Result(omnistate, decode_error),\n  )\n}\n\nEncoderDecoder(\n  msg_encoder: fn(msg) -&gt; Result(encoded_msg, Nil),\n  omnistate_decoder: fn(encoded_omnistate) -&gt;\n    Result(omnistate, decode_error),\n)\n\n\nSynonyms:\nlustre_omnistate.EncoderDecoder\nlustre_omnistate EncoderDecoder","url":"lustre_omnistate.html#EncoderDecoder"},{"doc":"lustre_omnistate","title":"OmniMessage","content":"pub type OmniMessage(omnistate, decode_error) {\n  OmnistateReceived(\n    Result(omnistate, OmnistateError(decode_error)),\n  )\n  TransportUp\n  TransportDown(code: Int, message: String)\n  TransportInitError(message: String)\n}\n\nOmnistateReceived(\n  Result(omnistate, OmnistateError(decode_error)),\n)\n\n\nTransportUp\n\n\nTransportDown(code: Int, message: String)\n\n\nTransportInitError(message: String)\n\n\nSynonyms:\nlustre_omnistate.OmniMessage\nlustre_omnistate OmniMessage","url":"lustre_omnistate.html#OmniMessage"},{"doc":"lustre_omnistate","title":"OmnistateError","content":"pub type OmnistateError(decode_error) {\n  DecodeErrors(decode_error)\n}\n\nDecodeErrors(decode_error)\n\n\nSynonyms:\nlustre_omnistate.OmnistateError\nlustre_omnistate OmnistateError","url":"lustre_omnistate.html#OmnistateError"},{"doc":"lustre_omnistate","title":"setup","content":"pub fn setup(\n  init: fn(a) -&gt; #(b, Effect(c)),\n  update: fn(d, e) -&gt; #(d, Effect(e)),\n  transport: Transport(f, g, h, i),\n  wrapper: fn(OmniMessage(j, k)) -&gt; c,\n  encoder_decoder: EncoderDecoder(g, j, f, e, k),\n) -&gt; #(fn(a) -&gt; #(b, Effect(c)), fn(d, e) -&gt; #(d, Effect(e)))\n\nSynonyms:\nlustre_omnistate.setup\nlustre_omnistate setup","url":"lustre_omnistate.html#setup"},{"doc":"lustre_omnistate","title":"lustre_omnistate","content":"","url":"lustre_omnistate.html"}]);